-- ********************************************************************
-- Fitxer: endevina_num_v4.adb
--------------------------------------------------------------------------
--
-- Descripcio:
--     Objectius:  - Aleatoris amb subrangs
--                    
-- Programador: Bea, Aida
-- E-mail: 
-- Assignatura: PR1
-- Data: 9-11-98, 20-3-01
-- Observacions:
--    Un cop s'hagi provat el programa, fer que generi un nmero 
--    entre 1 i 10 i un altre entre -1 i -10, els multipliqui, i
--    s'hagi d'endevinar el resultat.
-- ********************************************************************

with Ada.Text_IO; use Ada.Text_IO;
with Ada.Numerics.Discrete_Random;

procedure endevina_num_v4 is

  package i_io is new Ada.Text_IO.Integer_IO(integer); use i_io;
  subtype my_integer is integer range 0..100;
  package dr is new Ada.Numerics.Discrete_Random(my_integer); use dr;
  
  max: constant integer:= 10; -- nombre maxim d'intents
  
  procedure primer_intent(max: in integer; j: in out integer; n:out my_integer) is
  begin
    put("Has d'endevinar un numero de 0 a 100"); new_line;
    put("Tens fins a "); put(max); put(" intents."); new_line;
    put("Intent numero "); put(j); put(":"); get(n);
    j:=j+1;
  end primer_intent;

  procedure intent_seguent (j: in out integer; n:out my_integer) is
  begin
    put("Intent numero "); put(j); put(":"); get(n);
    j:=j+1;
  end intent_seguent;
  
  procedure comparar_i_respondre(n,correcte: in my_integer) is
  begin
    if n > correcte then put("Numero massa gran");
                 		 new_line;
    else put("Numero massa petit");
     	   new_line;
    end if;
  end comparar_i_respondre;

  procedure donar_resposta (correcte:in my_integer;j,max: in integer) is
  begin
    if j > max then put("Has esgotat totes les oportunitats"); new_line;
	                put("El numero era: "); put(correcte); 
               else put("Enhorabona: l'has encertat!");  
    end if;
    new_line;  
  end donar_resposta;

  correcte: my_integer;   -- nombre a encertar
  num: my_integer;  -- nombre que ha dit el jugador
  j: integer;  -- nombre d'intents gastats
  gen_i: generator;  
        -- El tipus generator esta definit en el paquet
        -- Ada.Numerics.Discrete_Random

  begin

    reset(gen_i); -- Preparar el sistema per a generar numeros
    correcte:=random(gen_i); -- generar numero aleatori

    j:=1;
    primer_intent(max,j,num);    
    while (correcte/=num) and (j <= max) loop
        comparar_i_respondre(num,correcte);
        intent_seguent(j,num);
    end loop;
    donar_resposta(correcte,j,max);
    
    exception
      when constraint_error => put("Aquest numero excedeix la capacitat");
                               new_line;
 
  end endevina_num_v4;

