-- Prctica 4 de Programaci 1. Curs 2000-01
-- *****************************************
-- Multicinemes. Multicinema.ads
-- *****************************************
-- Programadors: Aida i Arantza
-- Data: mar 2001
--------------------------------------------

with Ada.Text_IO; use Ada.Text_IO;

package multicinema is

  subtype num_sales is positive range 1..15; 
    -- Un cinema ha de tenir entre 1 i 15 sales
  subtype aforament is positive range 25..150;
    -- Una sala d'un cinema pot tenir entre 25 i 150 butaques
  subtype sessions is positive range 1..3;  
    -- Sempre es fan tres sessions de cada pel.lcula en una sala
    -- (primera sessi, segona i tercera)
  subtype temps is positive range 60..180; 
    -- Minuts que pot durar una pel.lcula, entre una i tres hores
  
  type genere is (comedia, ciencia_ficcio, accio, drama, infantil, 
                  X, terror, thriller, romantica, musical);
  type dia is (dilluns,dimarts,dimecres,dijous,divendres,
               dissabte,diumenge);

  type cinema is private;

  procedure crear_cinema (cine:out cinema;nom:string;
                          quantes_sales:in num_sales;
                          capacitat:in natural; dia_esp:in dia;
                          preu,preu_cs,preu_esp:in natural);
  -- Inicialitza la informaci de preus, dia de l'espectador, numero
  -- de sales i capacitat de les sales (totes les sales d'un mateix
  -- cinema tenen igual aforament.

  procedure posar_cartellera (f:in file_type; cine:in out cinema);
  -- El fitxer f cont la informaci de les pel.lcules que es 
  -- projectaran al cinema. Una lnia per cada sala del cinema.
  -- L'acci no obra ni tanca el fitxer, noms llegeix tantes
  -- linies com sales tingui el cine.
  -- Quan es llegeix el titol, s'acaba d'omplir l'string amb 
  -- espais en blanc
  
  function quina_peli (cine:cinema; sala:num_sales) return string;
  -- Retorna el titol de la pel.licula que es projecta a la sala
  -- indicada del cinema escollit

  function quin_genere (cine:cinema; sala:num_sales) return genere;
  -- Retorna el genere de la pel.licula que es projecta a la sala
  -- indicada del cinema escollit
  
  function durada (cine:cinema; sala:num_sales) return temps;
  -- Retorna la durada de la pel.licula que es projecta a la sala
  -- indicada del cinema escollit
  
  function quant_costa (cine:cinema;d:dia) return natural;
  -- Ens diu el preu de l'entrada per un dia concret de la setmana
  
  function esta_lliure (cine:cinema; sala:num_sales; quan:sessions; 
                   num_cadira:positive) return boolean;
  -- Retorna cert si la cadira indicada, de la sala, sessio i cinema
  -- escollits, esta lliure. Si es diu un numero de cadira que no hi
  -- es ens donara un missatge d'error i retornara un FALSE.
  
  function esta_tot_ple (cine:cinema; sala:num_sales; quan:sessions)
                        return boolean;
  -- Ens retorna cert si la sala demanada en la sessio indicada esta
  -- tota ocupada
  
  procedure ocupar (cine:in out cinema; sala:in num_sales;
                    quan:in sessions; num_cadira:in positive);
  -- Assigna la cadira indicada de la sala, sessio i cinema escollits
  -- Si es diu un numero de cadira que no existeix, sortira un 
  -- missatge d'error.
                 
  function mirar_nom (cine:cinema) return string;         
  -- Retorna el nom del cinema
  
  function mirar_capacitat (cine:cinema) return aforament;
  -- Retorna el numero de butaques que hi ha en les sales del cinema

  function quantes_sales (cine:cinema) return num_sales;
  -- Retorna el numero de sales que t el cinema
                      
private
  type seients is array (1..3,1..150) of boolean;  
    -- en cada sala es fan 3 sessions
    -- i cada sala te com a maxim 150 butaques
  
  type sala is record
     butaques :seients;
     pelicula :string (1..200);
     tipus :genere;
     durada :temps;  -- Durada en minuts
  end record;

  type info_sales is array (1..15) of sala;  
                            -- Poden haver-hi fins a 15 sales
  
  type cinema is record
     nom: string (1..30);
     sales :info_sales;
     quantes_sales :num_sales;
     capacitat :aforament;
     preu :natural;          -- Preu en pessetes els dies setmana
     preu_cap_setm :natural; -- Preu en pessetes els caps de setmana
     preu_espectador :natural; -- Preu en pessetes el dia de l'espect.
     dia_espectador :dia;
  end record;

end multicinema;